Home | History | Annotate | Line # | Download | only in kdc
      1 #!/bin/sh
      2 #
      3 # Copyright (c) 2006 - 2008 Kungliga Tekniska Hgskolan
      4 # (Royal Institute of Technology, Stockholm, Sweden). 
      5 # All rights reserved. 
      6 #
      7 # Redistribution and use in source and binary forms, with or without 
      8 # modification, are permitted provided that the following conditions 
      9 # are met: 
     10 #
     11 # 1. Redistributions of source code must retain the above copyright 
     12 #    notice, this list of conditions and the following disclaimer. 
     13 #
     14 # 2. Redistributions in binary form must reproduce the above copyright 
     15 #    notice, this list of conditions and the following disclaimer in the 
     16 #    documentation and/or other materials provided with the distribution. 
     17 #
     18 # 3. Neither the name of the Institute nor the names of its contributors 
     19 #    may be used to endorse or promote products derived from this software 
     20 #    without specific prior written permission. 
     21 #
     22 # THIS SOFTWARE IS PROVIDED BY THE INSTITUTE AND CONTRIBUTORS ``AS IS'' AND 
     23 # ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
     24 # IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
     25 # ARE DISCLAIMED.  IN NO EVENT SHALL THE INSTITUTE OR CONTRIBUTORS BE LIABLE 
     26 # FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
     27 # DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS 
     28 # OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
     29 # HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
     30 # LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
     31 # OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF 
     32 # SUCH DAMAGE. 
     33 
     34 top_builddir="@top_builddir@"
     35 env_setup="@env_setup@"
     36 objdir="@objdir@"
     37 
     38 . ${env_setup}
     39 
     40 # If there is no useful db support compiled in, disable test
     41 ${have_db} || exit 77
     42 
     43 testfailed="echo test failed; cat messages.log; exit \$ec"
     44 
     45 # If there is no useful db support compiled in, disable test
     46 ${have_db} || exit 77
     47 
     48 R=TEST.H5L.SE
     49 R2=TEST2.H5L.SE
     50 
     51 port=@port@
     52 pwport=@pwport@
     53 
     54 kadmin="${kadmin} -l -r $R"
     55 kdc="${kdc} --addresses=localhost -P $port"
     56 kpasswdd="${kpasswdd} --addresses=localhost -p $pwport"
     57 
     58 server=host/datan.test.h5l.se
     59 cache="FILE:${objdir}/cache.krb5"
     60 keytabfile=${objdir}/server.keytab
     61 keytab="FILE:${keytabfile}"
     62 
     63 kinit="${kinit} -c $cache ${afs_no_afslog}"
     64 klist="${klist} -c $cache"
     65 kgetcred="${kgetcred} -c $cache"
     66 kdestroy="${kdestroy} -c $cache ${afs_no_unlog}"
     67 
     68 KRB5_CONFIG="${objdir}/krb5.conf"
     69 export KRB5_CONFIG
     70 
     71 rm -f ${keytabfile}
     72 rm -f current-db*
     73 rm -f out-*
     74 rm -f mkey.file*
     75 
     76 > messages.log
     77 
     78 echo "Creating database for $R"
     79 ${kadmin} \
     80     init \
     81     --realm-max-ticket-life=1day \
     82     --realm-max-renewable-life=1month \
     83     ${R} || exit 1
     84 
     85 ${kadmin} add -p foo --use-defaults foo@${R} || exit 1
     86 ${kadmin} add -p kaka --use-defaults ${server}@${R} || exit 1
     87 ${kadmin} ext -k ${keytab} ${server}@${R} || exit 1
     88 
     89 echo "Creating database for ${R2}"
     90 ${kadmin} \
     91     init \
     92     --realm-max-ticket-life=1day \
     93     --realm-max-renewable-life=1month \
     94     ${R2} || exit 1
     95 
     96 ${kadmin} add -p foo --use-defaults bar@${R2} || exit 1
     97 
     98 echo "Doing database check for ${R} ${R2}"
     99 ${kadmin} check ${R} || exit 1
    100 ${kadmin} check ${R2} || exit 1
    101 
    102 echo foo > ${objdir}/foopassword
    103 
    104 echo Starting kdc ; > messages.log
    105 env ${HEIM_MALLOC_DEBUG} ${kdc} --detach --testing ||
    106     { echo "kdc failed to start"; exit 1; }
    107 kdcpid=`getpid kdc`
    108 
    109 echo Starting kpasswdd
    110 env ${HEIM_MALLOC_DEBUG} ${kpasswdd} --detach ||
    111     { echo "kpasswdd failed to start"; exit 1; }
    112 kpasswddpid=`getpid kpasswdd`
    113 
    114 trap "kill -9 ${kdcpid} ${kpasswddpid}; echo signal killing kdc; exit \$ec;" EXIT
    115 
    116 ec=0
    117 
    118 echo "Getting client initial tickets"; > messages.log
    119 ${kinit} --password-file=${objdir}/foopassword foo@$R || \
    120 	{ ec=1 ; eval "${testfailed}"; }
    121 echo "Getting tickets"; > messages.log
    122 ${kgetcred} ${server}@${R} || { ec=1 ; eval "${testfailed}"; }
    123 echo "Listing tickets"; > messages.log
    124 ${klist} > /dev/null || { ec=1 ; eval "${testfailed}"; }
    125 ${test_ap_req} ${server}@${R} ${keytab} ${cache} || \
    126 	{ ec=1 ; eval "${testfailed}"; }
    127 ${kdestroy}
    128 
    129 echo "checking ${R}"
    130 
    131 pw=ak4unandsop39NuJ
    132 
    133 echo "Changing password"
    134 cat > cpw.tmp <<EOF
    135 expect Password
    136 password foo\n
    137 expect New password
    138 send ${pw}\n
    139 expect New password
    140 send ${pw}\n
    141 expect Success
    142 EOF
    143 
    144 ${rkpty} cpw.tmp env ${kpasswd} foo@${R} || \
    145 	{ ec=$? ; eval "${testfailed}"; }
    146 
    147 rm cpw.tmp
    148 
    149 echo ${pw} > ${objdir}/barpassword
    150 
    151 
    152 echo "Getting client initial tickets for ${R}"; > messages.log
    153 ${kinit} --password-file=${objdir}/barpassword foo@$R || \
    154 	{ ec=1 ; eval "${testfailed}"; }
    155 echo "Getting tickets"; > messages.log
    156 ${kgetcred} ${server}@${R} || { ec=1 ; eval "${testfailed}"; }
    157 echo "Listing tickets"; > messages.log
    158 ${klist} > /dev/null || { ec=1 ; eval "${testfailed}"; }
    159 ${test_ap_req} ${server}@${R} ${keytab} ${cache} || \
    160 	{ ec=1 ; eval "${testfailed}"; }
    161 ${kdestroy}
    162 
    163 
    164 echo "checking ${R2}"
    165 
    166 cat > cpw.tmp <<EOF
    167 expect Password
    168 password foo\n
    169 expect New password
    170 send ${pw}\n
    171 expect New password
    172 send ${pw}\n
    173 expect Success
    174 EOF
    175 
    176 ${rkpty} cpw.tmp ../../kpasswd/kpasswd bar@${R2} || \
    177 	{ ec=$? ; eval "${testfailed}"; }
    178 
    179 rm cpw.tmp
    180 
    181 
    182 echo "Getting client initial tickets for ${R2}"; > messages.log
    183 ${kinit} --password-file=${objdir}/barpassword bar@${R2} || \
    184 	{ ec=1 ; eval "${testfailed}"; }
    185 ${kdestroy}
    186 
    187 
    188 echo "killing kdc (${kdcpid} ${kpasswddpid})"
    189 sh ${leaks_kill} kdc $kdcpid || exit 1
    190 sh ${leaks_kill} kpasswdd $kpasswddpid || exit 1
    191 
    192 trap "" EXIT
    193 
    194 exit $ec
    195